(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/common'), require('@angular/core'), require('@ibm-wch-sdk/ng-api'), require('typescript-logging')) :
    typeof define === 'function' && define.amd ? define('@ibm-wch-sdk/typescript-logger', ['exports', '@angular/common', '@angular/core', '@ibm-wch-sdk/ng-api', 'typescript-logging'], factory) :
    (global = global || self, factory((global['ibm-wch-sdk'] = global['ibm-wch-sdk'] || {}, global['ibm-wch-sdk']['typescript-logger'] = {}), global.ng.common, global.ng.core, global['@ibm-wch-sdk/ng-api'], global.typescriptLogging));
}(this, function (exports, common, core, ngApi, typescriptLogging) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); }
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    /* Copyright IBM Corp. 2018 */

    var TypescriptLoggerService = /** @class */ (function () {
        function TypescriptLoggerService() {
        }
        TypescriptLoggerService.prototype.create = function (name) {
            var cat = new typescriptLogging.Category(name);
            function info(msg) {
                var data = [];
                for (var _i = 1; _i < arguments.length; _i++) {
                    data[_i - 1] = arguments[_i];
                }
                // dispatch to the category
                cat.info({ msg: msg, data: data });
            }
            function error(msg) {
                var data = [];
                for (var _i = 1; _i < arguments.length; _i++) {
                    data[_i - 1] = arguments[_i];
                }
                // dispatch to the category
                cat.error(msg, new Error(msg));
            }
            function warn(msg) {
                var data = [];
                for (var _i = 1; _i < arguments.length; _i++) {
                    data[_i - 1] = arguments[_i];
                }
                // dispatch to the category
                cat.warn({ msg: msg, data: data });
            }
            return { info: info, error: error, warn: warn };
        };
        TypescriptLoggerService = __decorate([
            core.Injectable(),
            __metadata("design:paramtypes", [])
        ], TypescriptLoggerService);
        return TypescriptLoggerService;
    }());

    var WchTypescriptLoggingModule = /** @class */ (function () {
        /*
         * This contructor prevents the module from being imported multiple times.
         *
         * @param parentModule
         */
        function WchTypescriptLoggingModule(parentModule) {
            // do not allow recursive includes
            if (parentModule) {
                throw new Error('WchTypescriptLoggingModule is already loaded. Import it in the AppModule only');
            }
        }
        WchTypescriptLoggingModule_1 = WchTypescriptLoggingModule;
        /*
         * Returns the preconfigured module
         *
         * @param aService  the service
         */
        WchTypescriptLoggingModule.forRoot = function () {
            return {
                ngModule: WchTypescriptLoggingModule_1,
                providers: [
                    { provide: ngApi.WchLoggerFactory, useClass: TypescriptLoggerService }
                ]
            };
        };
        var WchTypescriptLoggingModule_1;
        WchTypescriptLoggingModule = WchTypescriptLoggingModule_1 = __decorate([
            core.NgModule({
                imports: [common.CommonModule]
            }),
            __param(0, core.Optional()), __param(0, core.SkipSelf()),
            __metadata("design:paramtypes", [WchTypescriptLoggingModule])
        ], WchTypescriptLoggingModule);
        return WchTypescriptLoggingModule;
    }());

    Object.defineProperty(exports, 'ɵa', {
        enumerable: true,
        get: function () {
            return ngApi.WchLoggerFactory;
        }
    });
    exports.WchTypescriptLoggingModule = WchTypescriptLoggingModule;
    exports.ɵb = TypescriptLoggerService;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=ibm-wch-sdk-typescript-logger.umd.js.map
