import { __decorate, __metadata, __param } from 'tslib';
import { CommonModule } from '@angular/common';
import { Injectable, NgModule, Optional, SkipSelf } from '@angular/core';
import { WchLoggerFactory } from '@ibm-wch-sdk/ng-api';
export { WchLoggerFactory as ɵa } from '@ibm-wch-sdk/ng-api';
import { Category } from 'typescript-logging';

/* Copyright IBM Corp. 2018 */

let TypescriptLoggerService = class TypescriptLoggerService {
    constructor() { }
    create(name) {
        const cat = new Category(name);
        function info(msg, ...data) {
            // dispatch to the category
            cat.info({ msg, data });
        }
        function error(msg, ...data) {
            // dispatch to the category
            cat.error(msg, new Error(msg));
        }
        function warn(msg, ...data) {
            // dispatch to the category
            cat.warn({ msg, data });
        }
        return { info, error, warn };
    }
};
TypescriptLoggerService = __decorate([
    Injectable(),
    __metadata("design:paramtypes", [])
], TypescriptLoggerService);

var WchTypescriptLoggingModule_1;
let WchTypescriptLoggingModule = WchTypescriptLoggingModule_1 = class WchTypescriptLoggingModule {
    /*
     * This contructor prevents the module from being imported multiple times.
     *
     * @param parentModule
     */
    constructor(parentModule) {
        // do not allow recursive includes
        if (parentModule) {
            throw new Error('WchTypescriptLoggingModule is already loaded. Import it in the AppModule only');
        }
    }
    /*
     * Returns the preconfigured module
     *
     * @param aService  the service
     */
    static forRoot() {
        return {
            ngModule: WchTypescriptLoggingModule_1,
            providers: [
                { provide: WchLoggerFactory, useClass: TypescriptLoggerService }
            ]
        };
    }
};
WchTypescriptLoggingModule = WchTypescriptLoggingModule_1 = __decorate([
    NgModule({
        imports: [CommonModule]
    }),
    __param(0, Optional()), __param(0, SkipSelf()),
    __metadata("design:paramtypes", [WchTypescriptLoggingModule])
], WchTypescriptLoggingModule);

/* Copyright IBM Corp. 2017 */

/**
 * Generated bundle index. Do not edit.
 */

export { WchTypescriptLoggingModule, TypescriptLoggerService as ɵb };
//# sourceMappingURL=ibm-wch-sdk-typescript-logger.js.map
