import { __decorate, __metadata, __param } from 'tslib';
import { CommonModule } from '@angular/common';
import { Injectable, NgModule, Optional, SkipSelf } from '@angular/core';
import { WchLoggerFactory } from '@ibm-wch-sdk/ng-api';
export { WchLoggerFactory as ɵa } from '@ibm-wch-sdk/ng-api';
import { Category } from 'typescript-logging';

/* Copyright IBM Corp. 2018 */

var TypescriptLoggerService = /** @class */ (function () {
    function TypescriptLoggerService() {
    }
    TypescriptLoggerService.prototype.create = function (name) {
        var cat = new Category(name);
        function info(msg) {
            var data = [];
            for (var _i = 1; _i < arguments.length; _i++) {
                data[_i - 1] = arguments[_i];
            }
            // dispatch to the category
            cat.info({ msg: msg, data: data });
        }
        function error(msg) {
            var data = [];
            for (var _i = 1; _i < arguments.length; _i++) {
                data[_i - 1] = arguments[_i];
            }
            // dispatch to the category
            cat.error(msg, new Error(msg));
        }
        function warn(msg) {
            var data = [];
            for (var _i = 1; _i < arguments.length; _i++) {
                data[_i - 1] = arguments[_i];
            }
            // dispatch to the category
            cat.warn({ msg: msg, data: data });
        }
        return { info: info, error: error, warn: warn };
    };
    TypescriptLoggerService = __decorate([
        Injectable(),
        __metadata("design:paramtypes", [])
    ], TypescriptLoggerService);
    return TypescriptLoggerService;
}());

var WchTypescriptLoggingModule = /** @class */ (function () {
    /*
     * This contructor prevents the module from being imported multiple times.
     *
     * @param parentModule
     */
    function WchTypescriptLoggingModule(parentModule) {
        // do not allow recursive includes
        if (parentModule) {
            throw new Error('WchTypescriptLoggingModule is already loaded. Import it in the AppModule only');
        }
    }
    WchTypescriptLoggingModule_1 = WchTypescriptLoggingModule;
    /*
     * Returns the preconfigured module
     *
     * @param aService  the service
     */
    WchTypescriptLoggingModule.forRoot = function () {
        return {
            ngModule: WchTypescriptLoggingModule_1,
            providers: [
                { provide: WchLoggerFactory, useClass: TypescriptLoggerService }
            ]
        };
    };
    var WchTypescriptLoggingModule_1;
    WchTypescriptLoggingModule = WchTypescriptLoggingModule_1 = __decorate([
        NgModule({
            imports: [CommonModule]
        }),
        __param(0, Optional()), __param(0, SkipSelf()),
        __metadata("design:paramtypes", [WchTypescriptLoggingModule])
    ], WchTypescriptLoggingModule);
    return WchTypescriptLoggingModule;
}());

/* Copyright IBM Corp. 2017 */

/**
 * Generated bundle index. Do not edit.
 */

export { WchTypescriptLoggingModule, TypescriptLoggerService as ɵb };
//# sourceMappingURL=ibm-wch-sdk-typescript-logger.js.map
